<?php

//Main plugin functions here
class MetaSeo_Admin {
    
    private $options;
    private $pagenow;
    public static $desc_length = 156;
    public static $title_length = 69;
    
    public static $metaseo_twitter_card = array(
            'summary'             => '',
            'summary_large_image' => '',
    );
    
    function __construct() {
        self::$metaseo_twitter_card['summary']             = __( 'Summary', 'wpms' );
        self::$metaseo_twitter_card['summary_large_image'] = __( 'Summary with large image', 'wpms' );
        
        $this->settings = array(
            "metaseo_title_home"=>"",
            "metaseo_desc_home"=>"",
	    "metaseo_showfacebook"=>"",
            "metaseo_showtwitter"=>"",
            "metaseo_twitter_card"=>"summary",
            "metaseo_showtmetablock"=>0
	);
	$settings = get_option( '_metaseo_settings' );
	if(is_array($settings)){
	    $this->settings = array_merge($this->settings, $settings);
	}
        
        $this->pagenow = $GLOBALS['pagenow'];
        if($this->settings['metaseo_showtmetablock'] == 1 || empty($this->settings['metaseo_installnew'])){
            $this->load_meta_boxes();
        }
        
        add_action('admin_menu', array($this, 'register_menu_page'));

        /** Load admin js * */
        add_action('admin_enqueue_scripts', array($this, 'loadAdminScripts'));

        /** Load admin css  * */
        add_action('admin_init', array($this, 'addAdminStylesheets'));        
		
        $this->ajaxHandle();
        
        //register ajax update meta handler...
        add_action( 'wp_ajax_updateContentMeta', array($this, 'updateContentMeta_callback') );
        add_action( 'admin_init', array($this, 'stop_heartbeat') , 1 );
        add_action('admin_init', array($this,'metaseo_field_settings'));
        add_action('init', array($this,'wpms_load_langguage'));
        add_action('wp_ajax_metaseo_reload_analysis',array($this,'metaseo_reload_analysis'));

    }
    
    function wpms_load_langguage(){
        load_plugin_textdomain( 'wpms', false, dirname( plugin_basename( WPMSEO_FILE ) ) . '/languages/' );
    }
    
    function metaseo_reload_analysis() {
        if(empty($_POST['datas'])){
            wp_send_json(false);
        }
        $check = 0;
        $output = '';
        // title heading
        if($_POST['datas']['meta_title'] != ''){
            $words_meta_title = preg_split('~[^\p{L}\p{N}\']+~u',strtolower($_POST['datas']['meta_title']));//explode(' ' , strtolower($meta_title)); 
            $words_post_title = preg_split('~[^\p{L}\p{N}\']+~u',strtolower($_POST['datas']['title'])); //explode(' ' , strtolower($post->post_title));
            
            $test = false;
            if(is_array($words_meta_title) && is_array($words_post_title)){
                foreach ($words_meta_title as $mtitle){
                    if(in_array($mtitle, $words_post_title) && $mtitle != ''){
                        $test = true;
                    }
                }
            }else{
                $test = false;
            }

            if($test){
                $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before dashicons-yes"></div>'.__('Page title word in content heading','wpms').'</div>';
                $check ++;
            }else{
                $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before icons-mwarning"></div>'.__('Page title word in content heading','wpms').'</div>';
            }
           
        }else{
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before dashicons-yes"></div>'.__('Page title word in content heading','wpms').'</div>';
            $check ++;
        }
        
        // title content
        $words_title = preg_split('~[^\p{L}\p{N}\']+~u',strtolower($_POST['datas']['title']));
        $words_post_content = preg_split('~[^\p{L}\p{N}\']+~u',strtolower($_POST['datas']['content'])); 
        
        $test1 = false;
        if(is_array($words_title) && is_array($words_post_content)){
            foreach ($words_title as $mtitle){
                if(in_array($mtitle, $words_post_content) && $mtitle != ''){
                    $test1 = true;
                }
            }
        }else{
            $test1 = false;
        }
        
        if($test1){
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before dashicons-yes"></div>'.__('Page title word in content','wpms').'</div>';
            $check ++;
        }else{
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before icons-mwarning"></div>'.__('Page title word in content','wpms').'</div>';
        }
        
        // page url matches page title
        $mtitle = $_POST['datas']['title'];
        if($_POST['datas']['mpageurl'] == sanitize_title($mtitle)){
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before dashicons-yes"></div>'.__('Page url matches with page title','wpms').'</div>';
            $check ++;
        }else{
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before icons-mwarning"></div>'.__('Page url matches with page title','wpms').'</div>';
        }
        
        // meta title filled
        if($_POST['datas']['meta_title'] != '' && strlen($_POST['datas']['meta_title']) <= self::$title_length){
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before dashicons-yes"></div>'.__('Meta title filled','wpms').'</div>';
            $check++;
        }else{
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before icons-mwarning"></div>'.__('Meta title filled','wpms').'</div>';
        }
        
        // desc filled
        if($_POST['datas']['meta_desc'] != '' && strlen($_POST['datas']['meta_desc']) <= self::$desc_length){
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before dashicons-yes"></div>'.__('Meta description filled','wpms').'</div>';
            $check++;
        }else{
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before icons-mwarning"></div>'.__('Meta description filled','wpms').'</div>';
        }
        
        // image resize
        if($_POST['datas']['content'] == '') {
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before dashicons-yes"></div>'.__('Wrong image resize','wpms').'</div>';
            $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before dashicons-yes"></div>'.__('Image have meta title or alt','wpms').'</div>';
            $check += 2;
        }else{
            $dom = new DOMDocument;
           
            if ($dom->loadHTML('<div>'.html_entity_decode(stripcslashes($_POST['datas']['content'])).'</div>')) {
                // Extracting the specified elements from the web page
                $tags = $dom->getElementsByTagName('img');
                $img_wrong = false;
                $img_wrong_alt = false;
                foreach($tags as $order => $tag){
                    $src = $tag->getAttribute('src');
                    $b = strrpos($src, '-');
                    $e = strrpos($src, '.');
                    $string_wh = substr($src, $b+1 , $e-$b-1);
                    $array_wh = explode('x', $string_wh);
                    if(!empty($array_wh[0]) && !empty($array_wh[1])){
                        if(((int)$array_wh[0] != (int)$tag->getAttribute('width')) || ((int)$array_wh[1] != (int)$tag->getAttribute('height'))){
                            $img_wrong = true;
                        }
                    }
                    
                    $image_title = $tag->getAttribute('title');
                    $image_alt = $tag->getAttribute('alt');
                    if($image_title == '' || $image_alt == ''){
                        $img_wrong_alt = true;
                    }
                }

                if($img_wrong){
                    $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before icons-mwarning"></div>'.__('Wrong image resize','wpms').'</div>';
                }else{
                    $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before dashicons-yes"></div>'.__('Wrong image resize','wpms').'</div>';
                    $check++;
                }
                
                if($img_wrong_alt){
                    $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before icons-mwarning"></div>'.__('Image have meta title or alt','wpms').'</div>';
                }else{
                    $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before dashicons-yes"></div>'.__('Image have meta title or alt','wpms').'</div>';
                    $check++;
                }

            }else{
                $output .= '<div class="metaseo_analysis"><div class="metaseo-dashicons dashicons-before icons-mwarning"></div>'.__('Wrong image resize','wpms').'</div>';
            }
        }
        
        $circliful = ceil(100*($check)/7);
        wp_send_json(array('circliful' => $circliful,'output' => $output));
        
    }
    
    function metaseo_field_settings(){
        register_setting('Wp Meta SEO','_metaseo_settings');
        add_settings_section('metaseo_dashboard','',array( $this, 'showSettings' ),'metaseo_settings');  
        add_settings_field('metaseo_title_home', __('Homepage meta title ', 'wpms'), array( $this, 'metaseo_title_home' ), 'metaseo_settings', 'metaseo_dashboard');   
        add_settings_field('metaseo_desc_home', __('Homepage meta description ', 'wpms'), array( $this, 'metaseo_desc_home' ), 'metaseo_settings', 'metaseo_dashboard');   
        add_settings_field('metaseo_showfacebook', __('Facebook profile URL ', 'wpms'), array( $this, 'showfacebook' ), 'metaseo_settings', 'metaseo_dashboard');   
        add_settings_field('metaseo_showtwitter', __('Twitter Username ', 'wpms'), array( $this, 'showtwitter' ), 'metaseo_settings', 'metaseo_dashboard');   
        add_settings_field('metaseo_twitter_card', __('The default card type to use ', 'wpms'), array( $this, 'showtwittercard' ), 'metaseo_settings', 'metaseo_dashboard');   
        add_settings_field('metaseo_showtmetablock', __('Meta block edition ', 'wpms'), array( $this, 'showtmetablock' ), 'metaseo_settings', 'metaseo_dashboard');   
    }
    
    public function showSettings(){
	
    }
    
    public function metaseo_title_home(){
	$home_title = isset( $this->settings['metaseo_title_home'] ) ? $this->settings['metaseo_title_home'] : '';
	echo '<input id="metaseo_title_home" name="_metaseo_settings[metaseo_title_home]" type="text" value="'.esc_attr( $home_title ).'" size="50"/>';
    }
    
    public function metaseo_desc_home(){
	$home_desc = isset( $this->settings['metaseo_desc_home'] ) ? $this->settings['metaseo_desc_home'] : '';
	echo '<input id="metaseo_desc_home" name="_metaseo_settings[metaseo_desc_home]" type="text" value="'.esc_attr( $home_desc ).'" size="50"/>';
    }
    
    public function showtmetablock(){
	echo '<input id="metaseo_installnew" name="_metaseo_settings[metaseo_installnew]" type="hidden" value="old"/>';
        if(!empty($this->settings['metaseo_showtmetablock'])){
            $show = $this->settings['metaseo_showtmetablock'];
        }else{
            $show = 0;
        }
        
        if(empty($this->settings['metaseo_installnew'])){
            $show = 1;
        }
        ?>
        <label><input name="_metaseo_settings[metaseo_showtmetablock]" type="checkbox" id="metaseo_showtmetablock" value="1" <?php checked( 1, ($show == 0)?0:1); ?> />
	<?php _e( 'Show/hide meta block edition below content' ); ?></label>
        <?php
    }
    
    public function showfacebook(){
	$face = isset( $this->settings['metaseo_showfacebook'] ) ? $this->settings['metaseo_showfacebook'] : '';
	echo '<input id="metaseo_showfacebook" name="_metaseo_settings[metaseo_showfacebook]" type="text" value="'.esc_attr( $face ).'" size="50"/>';
    }
    
    public function showtwitter(){
	$twitter = isset( $this->settings['metaseo_showtwitter'] ) ? $this->settings['metaseo_showtwitter'] : '';
	echo '<input id="metaseo_showtwitter" name="_metaseo_settings[metaseo_showtwitter]" type="text" value="'.esc_attr( $twitter ).'" size="50"/>';
    }
    
    public function showtwittercard(){
	$twitter_card = isset( $this->settings['metaseo_twitter_card'] ) ? $this->settings['metaseo_twitter_card'] : 'summary';
        echo '<select class="select" name="_metaseo_settings[metaseo_twitter_card]" id="metaseo_twitter_card">';
        foreach (self::$metaseo_twitter_card as $k => $v){
            if($twitter_card == $k){
                echo '<option selected value="'.$k.'">'.$v.'</option>';
            }else{
                echo '<option value="'.$k.'">'.$v.'</option>';
            }
        }
        echo '</select>';
    }
    
    private function load_meta_boxes() {
            if ( in_array( $this->pagenow, array(
                            'edit.php',
                            'post.php',
                            'post-new.php',
                    ) ) || apply_filters( 'wpmseo_always_register_metaboxes_on_admin', false )
            ) {
                require_once( WPMETASEO_PLUGIN_DIR . 'inc/class.metaseo-metabox.php' );
                $GLOBALS['wpmseo_metabox'] = new WPMSEO_Metabox;
            }
    }
    
    function stop_heartbeat() {
         global $pagenow;
         if ( 'post.php' != $pagenow && 'post-new.php' != $pagenow )        
            wp_deregister_script('heartbeat');
    }

    function updateContentMeta_callback() {
         global $wpdb;
         $_POST = stripslashes_deep( $_POST );
		 $response = new stdClass();
		 
		 if( !empty( $_POST['metakey'] ) && !empty( $_POST['postid'] ) && !empty( $_POST['value'] ) );
         $metakey = strtolower(trim($_POST['metakey']));
         $postID =  intval($_POST['postid']);
		 $value = trim($_POST['value']);
         
//		 if(preg_match('/[<>\/\'\"]+/', $value)){
//			$response->updated = false;
//			$response->msg = 'Meta content should not contains html tag or special char';
//			
//			echo json_encode($response);
//			wp_die();
//		}
         
         $response->msg = __('Modification was saved', 'wpms') ;
         if($metakey == 'metatitle') {           
             if(!update_post_meta($postID, '_metaseo_metatitle', $value)) {
                 $response->updated = false;
                 $response->msg = __('Meta title was not saved', 'wpms') ;
             }
			 else{
			 	$response->updated = true;
                $response->msg = __('Meta title was saved', 'wpms') ;
			 }          
		 }
		 
         if($metakey =='metadesc') {
             if(!update_post_meta($postID, '_metaseo_metadesc', $value)) {
                  $response->updated = false;
                  $response->msg = __('Meta description was not saved', 'wpms') ;
             }
			 else{
			 	$response->updated = true;
                $response->msg = __('Meta description was saved', 'wpms') ;
			 }        
		}
           
         echo json_encode($response);
         wp_die();
    }
      
    /**
     * Loads js/ajax scripts
     * 
     */
    public function loadAdminScripts($hook) {
        global $current_screen;
        wp_enqueue_script('jquery');

        wp_enqueue_script(
                'wpmetaseoAdmin', plugins_url('js/metaseo_admin.js', dirname(__FILE__)), array('jquery'), WPMSEO_VERSION, true
        );
        
        if($current_screen->base == 'wp-meta-seo_page_metaseo_image_meta' || $current_screen->base == 'wp-meta-seo_page_metaseo_content_meta'){
            wp_enqueue_script('wpms-bulk', plugins_url('js/wpms-bulk-action.js', dirname(__FILE__)), array('jquery'), WPMSEO_VERSION, true);
            wp_localize_script('wpms-bulk', 'wpmseobulkL10n', $this->meta_seo_localize_script());
        }
        
        if($current_screen->base == 'toplevel_page_metaseo_dashboard'){
            wp_enqueue_script('Chart', plugins_url('js/Chart.js', dirname(__FILE__)), array('jquery'), WPMSEO_VERSION, true);
            wp_enqueue_script('jquery-knob', plugins_url('js/jquery.knob.js', dirname(__FILE__)), array('jquery'), WPMSEO_VERSION, true);
            wp_enqueue_script('metaseo-dashboard', plugins_url('js/dashboard.js', dirname(__FILE__)), array('jquery'), WPMSEO_VERSION, true);
            wp_enqueue_style('chart', plugins_url('/css/chart.css', dirname(__FILE__) ) );
            wp_enqueue_style('metaseo-quirk', plugins_url('/css/metaseo-quirk.css', dirname(__FILE__) ) );
        }
        
        if($current_screen->base == 'wp-meta-seo_page_metaseo_image_meta'){
            wp_enqueue_script('mautosize', plugins_url('js/autosize.js', dirname(__FILE__)), array('jquery'), '0.1', true);
        }
        // in JavaScript, object properties are accessed as ajax_object.ajax_url, ajax_object.we_value
	wp_localize_script( 'wpmetaseoAdmin', 'myAjax',
            array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
    }

    public function meta_seo_localize_script() {
        return array(
            'metaseo_message_false_copy' => __( 'We didn\'t find any element to apply a batch copy, congrats!', 'wpms' ),
        );
    }
    
    /**
     * Load additional admin stylesheets
     * of jquery-ui
     *
     */
    function addAdminStylesheets() {
        wp_enqueue_style('wpmetaseoAdmin', plugins_url('css/metaseo_admin.css', dirname(__FILE__)));        
        wp_enqueue_style('tooltip-metaimage', plugins_url('/css/tooltip-metaimage.css',dirname(__FILE__)));
        wp_enqueue_style('style', plugins_url('/css/style.css', dirname(__FILE__) ) );
    }

    function register_menu_page() {

        // Add main page
        $admin_page = add_menu_page(__('WP Meta SEO:', 'wpms') . ' ' . __('Dashboard', 'wpms'), __('WP Meta SEO', 'wpms'), 'manage_options', 'metaseo_dashboard', array(
            $this,'load_page',) , 'dashicons-chart-area' );

        /**
         * Filter: 'metaseo_manage_options_capability' - Allow changing the capability users need to view the settings pages
         *
         * @api string unsigned The capability
         */
        $manage_options_cap = apply_filters('metaseo_manage_options_capability', 'manage_options');

        // Sub menu pages
        $submenu_pages = array(
            array(
                'metaseo_dashboard',
                '',
                __('Content meta', 'wpms'),
                $manage_options_cap,
                'metaseo_content_meta',
                array($this, 'load_page'),
                null,
            ),
            array(
                'metaseo_dashboard',
                '',
                __('Image meta', 'wpms'),
                $manage_options_cap,
                'metaseo_image_meta',
                array($this, 'load_page'),
                null,
            ),
            array(
                'metaseo_dashboard',
                '',
                __('Settings', 'wpms'),
                $manage_options_cap,
                'metaseo_settings',
                array($this, 'load_page'),
                null,
            ),
        );



        // Allow submenu pages manipulation
        $submenu_pages = apply_filters('metaseo_submenu_pages', $submenu_pages);

        // Loop through submenu pages and add them
        if (count($submenu_pages)) {
            foreach ($submenu_pages as $submenu_page) {

                // Add submenu page
                $admin_page = add_submenu_page($submenu_page[0], $submenu_page[2] . ' - ' . __('WP Meta SEO:', 'wpms'), $submenu_page[2], $submenu_page[3], $submenu_page[4], $submenu_page[5]);

                // Check if we need to hook
                if (isset($submenu_page[6]) && null != $submenu_page[6] && is_array($submenu_page[6]) && count($submenu_page[6]) > 0) {
                    foreach ($submenu_page[6] as $submenu_page_action) {
                        add_action('load-' . $admin_page, $submenu_page_action);
                    }
                }
            }
        }

        global $submenu;
        if (isset($submenu['metaseo_dashboard']) && current_user_can($manage_options_cap)) {
            $submenu['metaseo_dashboard'][0][0] = __('Dashboard', 'wpms');
        }
    }

    /**
     * Load the form for a WPSEO admin page
     */
    function load_page() {
        if (isset($_GET['page'])) {
            switch ($_GET['page']) {
                case 'metaseo_settings':
                    require_once( WPMETASEO_PLUGIN_DIR . 'inc/pages/settings.php' );
                    break;
                
                case 'metaseo_content_meta':
                    require_once( WPMETASEO_PLUGIN_DIR . 'inc/pages/content-meta.php' );
                    break;


                case 'metaseo_image_meta':
                    require_once( WPMETASEO_PLUGIN_DIR . 'inc/pages/image-meta.php' );
                    break;

                case 'metaseo_image_optimize':
                    require_once( WPMETASEO_PLUGIN_DIR . 'inc/pages/image-optimize.php' );
                    break;

                case 'metaseo_dashboard':
                default:
                    require_once( WPMETASEO_PLUGIN_DIR . 'inc/pages/dashboard.php' );
                    break;
            }
        }
    }
    
    function wpms_bulk_image_copy(){
        global $wpdb;
        if(empty($_POST['mtype'])) wp_send_json (false);
        if(isset($_POST['sl_bulk']) && $_POST['sl_bulk'] == 'all'){
            // select all
            $limit = 500;
            // check image alt and title empty
            $margs = array(
                'posts_per_page' => -1,'post_type' => 'attachment','post_status' => 'any',
                'meta_query' => array(
                    'relation' => 'OR',
                    array(
                        'key' => '_wp_attachment_image_alt',
                        'compare' => 'NOT EXISTS',
                    ),
                    array(
                        'key' => '_wp_attachment_image_alt',
                        'value' => false,
                        'type' => 'BOOLEAN'
                    ),
            ));  
                
            $m_newquery = new WP_Query( $margs );
            $mposts_empty_alt = $m_newquery->get_posts();
            $check_title = $wpdb->get_var("SELECT COUNT(posts.ID) as total FROM ".$wpdb->prefix."posts as posts WHERE posts.post_type = 'attachment' AND post_title = ''");
            
            switch ($_POST['mtype']){
                case 'image_alt':
                    if(count($mposts_empty_alt) == 0 ) wp_send_json (false);
                break;

                case 'image_title':
                    if($check_title == 0) wp_send_json (false);
                break;
            }
            
            // query attachment and update meta
            $total = $wpdb->get_var("SELECT COUNT(posts.ID) as total FROM ".$wpdb->prefix."posts as posts WHERE posts.post_type = 'attachment'");
            
            $j = ceil((int)$total/$limit);
            for($i = 0;$i<=$j; $i++){
                $ofset = $i*$limit;
                $attachments = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."posts as posts
                       WHERE posts.post_type = 'attachment' LIMIT $limit OFFSET $ofset");
                
                foreach ($attachments as $attachment){
                    $i_info_url = pathinfo($attachment->guid);
                    $i_alt = get_post_meta($attachment->ID,'_wp_attachment_image_alt',true);
                    
                    switch ($_POST['mtype']){
                        case 'image_alt':
                            if($i_alt == ''){
                                update_post_meta($attachment->ID , '_wp_attachment_image_alt',$i_info_url['filename']);
                            }
                        break;
                            
                        case 'image_title':
                            if($attachment->post_title == ''){
                                wp_update_post(array('ID' => $attachment->ID,'post_title' => $i_info_url['filename']));
                            }
                        break;
                    }
                }
            }
            
            wp_send_json(true);
            
        }else{
            // selected
            if(isset($_POST['ids'])){
                $ids = $_POST['ids'];
                $margs = array(
                    'posts_per_page' => -1,
                    'post_type'        => 'attachment',
                    'post_status' => 'any',
                    'post__in' => $ids,
                    'meta_query' => array(
                        'relation' => 'OR',
                        array(
                            'key' => '_wp_attachment_image_alt',
                            'compare' => 'NOT EXISTS',
                        ),
                        array(
                            'key' => '_wp_attachment_image_alt',
                            'value' => false,
                            'type' => 'BOOLEAN'
                        ),
                ));  
                
                $query = "SELECT *
                        FROM $wpdb->posts
                        WHERE `post_type` = 'attachment'
                        AND `post_mime_type` LIKE '%image%' 
                        AND `post_title` = '' 
                        AND `ID` IN (".  implode(',', $ids).") 
                        ";
                
                $m_newquery = new WP_Query( $margs );
                $mposts_empty_alt = $m_newquery->get_posts();
                $mposts_empty_title = $wpdb->get_results($query);
                
                switch ($_POST['mtype']){
                    case 'image_alt':
                        if(!empty($mposts_empty_alt)){
                            foreach ($mposts_empty_alt as $post){
                                $i_info_url = pathinfo($post->guid);
                                update_post_meta($post->ID , '_wp_attachment_image_alt',$i_info_url['filename']);
                            }
                        }else{
                            wp_send_json(false);
                        }
                    break;

                    case 'image_title':
                        if(!empty($mposts_empty_title)){
                            foreach ($mposts_empty_title as $post){
                                $i_info_url = pathinfo($post->guid);
                                wp_update_post(array('ID' => $post->ID,'post_title' => $i_info_url['filename']));
                            }
                        }else{
                            wp_send_json(false);
                        }
                    break;
                }
                wp_send_json(true);
                
            }else{
                wp_send_json(false);
            }
        }
        
        
    }
    
    function wpms_bulk_post_copy_title(){
        $post_types = get_post_types( array('public' => true, 'exclude_from_search' => false) ) ;
        unset($post_types['attachment']);
        if(isset($_POST['sl_bulk']) && $_POST['sl_bulk'] == 'all'){
            $margs = array(
                'posts_per_page' => -1,
                'post_type'        => $post_types,
                'post_status' => array('publish', 'pending', 'draft', 'auto-draft', 'future', 'private', 'inherit', 'trash') ,
                'meta_query' => array(
                    'relation' => 'OR',
                    array(
                        'key' => '_metaseo_metatitle',
                        'compare' => 'NOT EXISTS',
                    ),
                    array(
                        'key' => '_metaseo_metatitle',
                        'value' => false,
                        'type' => 'BOOLEAN'
                    ),
            ));   
        }else{
            if(isset($_POST['ids'])){
                $ids = $_POST['ids'];
                $margs = array(
                    'posts_per_page' => -1,
                    'post_type'        => $post_types,
                    'post_status' => array('publish', 'pending', 'draft', 'auto-draft', 'future', 'private', 'inherit', 'trash') ,
                    'post__in' => $ids,
                    'meta_query' => array(
                        'relation' => 'OR',
                        array(
                            'key' => '_metaseo_metatitle',
                            'compare' => 'NOT EXISTS',
                        ),
                        array(
                            'key' => '_metaseo_metatitle',
                            'value' => false,
                            'type' => 'BOOLEAN'
                        ),
                ));  
            }else{
                wp_send_json(false);
            }
                
        }
        
        $m_newquery = new WP_Query( $margs );
        $mposts = $m_newquery->get_posts();
        if(!empty($mposts)){
            foreach ($mposts as $post){
                update_post_meta($post->ID , '_metaseo_metatitle',$post->post_title);
            }
            wp_send_json(true);
        }else{
                
            wp_send_json(false);
        }

        
    }
	
	private function ajaxHandle(){
	//
	add_action( 'wp_ajax_scanPosts', array('MetaSeo_Image_List_Table', 'scan_posts_callback') );
	add_action( 'wp_ajax_load_posts', array('MetaSeo_Image_List_Table', 'load_posts_callback') );
	add_action( 'wp_ajax_optimize_imgs', array('MetaSeo_Image_List_Table', 'optimizeImages') );
	add_action( 'wp_ajax_updateMeta', array('MetaSeo_Image_List_Table', 'updateMeta_callback') );
	//add_action( 'wp_ajax_opt_checking', array('MetaSeo_Dashboard', 'optimizationChecking') );
	//
	add_action( 'wp_ajax_import_meta_data', array('MetaSeo_Content_List_Table', 'importMetaData') );
	add_action( 'wp_ajax_dismiss_import_meta', array('MetaSeo_Content_List_Table', 'dismissImport') );
        add_action('wp_ajax_wpms_bulk_post_copy',array($this,'wpms_bulk_post_copy_title'));
        add_action('wp_ajax_wpms_bulk_image_copy',array($this,'wpms_bulk_image_copy'));
        
	//
	add_action( 'added_post_meta' , array( 'MetaSeo_Content_List_Table', 'updateMetaSync' ), 99, 4);
	add_action( 'updated_post_meta', array( 'MetaSeo_Content_List_Table', 'updateMetaSync' ), 99, 4);
	add_action( 'deleted_post_meta', array( 'MetaSeo_Content_List_Table', 'deleteMetaSync' ), 99, 4);
	
	}

}